<link rel="import" href="../../../html/polymer.html">

<link rel="import" href="chrome://resources/polymer/v1_0/iron-flex-layout/iron-flex-layout-classes.html">
<link rel="import" href="chrome://resources/polymer/v1_0/iron-icon/iron-icon.html">
<link rel="import" href="chrome://resources/polymer/v1_0/paper-spinner/paper-spinner-lite.html">
<link rel="import" href="../../../html/i18n_behavior.html">
<link rel="import" href="../../../cr_elements/cr_input/cr_input.html">
<link rel="import" href="base_page.html">
<link rel="import" href="cellular_setup_delegate.html">
<link rel="import" href="cellular_setup_icons.html">

<dom-module id="activation-code-page">
  <template>
    <style include="iron-positioning">
      [slot='page-body'] {
        height: 300px;
        margin-top: -20px;
      }

      :host cr-button {
        --ripple-opacity: 0;
      }

      #esimQrCodeDetection {
        background-color: var(--google-grey-refresh-100);
        border-radius: 4px;
        height: 130px;
        margin: 20px 0 30px 0;
        overflow: hidden;
        position: relative;
      }

      cr-button {
        border: none;
        box-shadow: none;
      }

      cr-button:hover {
        background-color: transparent;
      }

      .center {
        left: 50%;
        position: absolute;
        top: 50%;
        transform: translateY(-50%) translateX(-50%);
      }

      .label {
        font-weight: 500;
      }

      .button-image {
        margin-inline-end: 8px;
      }

      .scan-finish-image {
        position: absolute;
       }

      .scan-finish-message {
        padding-inline-end: 0;
        padding-inline-start: 30px;
      }

      .scan-finish-message:hover {
        cursor: default;
      }

      #startScanningContainer {
        --iron-icon-fill-color: #1A73E8;
      }

      #scanSuccessContainer {
        --iron-icon-fill-color: #1E8E3E;
        margin-bottom: 8px;
      }

      #scanSuccessMessage {
        color: green;
        font-size: medium;
      }

      #scanFailureContainer {
        --iron-icon-fill-color: #D93025;
        margin-bottom: 4px;
      }

      #scanFailureMessage {
        color: var(--google-red-600);
      }

      #useCameraAgainButton {
        display: block;
        font-weight: 500;
        text-align: center;
      }

      #switchCameraButton {
        background-color: rgba(0, 0, 0, 0.04);
        border-radius: 4px;
        color: var(--google-grey-refresh-300);
        margin: 8px;
        padding: 8px;
        position: absolute;
        right: 0;
        z-index: 2;
      }

      #switchCameraButton iron-icon {
        filter: brightness(2.1);
        --iron-icon-fill-color: #5F6368;
      }

      paper-spinner-lite {
        height: 20px;
        position: absolute;
        right: 16px;
        top: 24px;
        width: 20px;
      }

      #loadingMessage {
        bottom: 0;
        color: var(--google-grey-refresh-500);
        font-size: var(--cr-form-field-label-font-size);
        letter-spacing: .4px;
        line-height: var(--cr-form-field-label-line-height);
        position: absolute;
      }
    </style>
    <base-page>
      <div slot="page-body">
        <span id="scanQrCodeDescription">
          [[getDescription_(showNoProfilesMessage)]]
        </span>
        <div id="esimQrCodeDetection">
          <cr-button id="switchCameraButton"
              on-click="onSwitchCameraButtonPressed_"
              hidden$="[[isUiElementHidden_(UiElement.SWITCH_CAMERA, state_, hasMultipleCameras_)]]"
              disabled="[[isUiElementDisabled_(UiElement.SWITCH_CAMERA, state_)]]">
            <iron-icon class="button-image" icon="cellular-setup:switch-camera"></iron-icon>
            [[i18n('switchCamera')]]
          </cr-button>
          <video id="video"
              hidden$="[[isUiElementHidden_(UiElement.VIDEO, state_)]]">
          </video>
          <div class="center" id="startScanningContainer"
              hidden$="[[isUiElementHidden_(UiElement.START_SCANNING, state_)]]">
            <cr-button class="label"
                id="startScanningButton"
                on-click="startScanning_"
                aria-describedby="scanQrCodeDescription">
              <iron-icon class="button-image" icon="cellular-setup:camera"></iron-icon>
              [[i18n('useCamera')]]
            </cr-button>
          </div>
          <div class="center" id="scanFinishContainer"
              hidden$="[[isUiElementHidden_(UiElement.SCAN_FINISH, state_)]]">
            <div>
              <div id="scanSuccessContainer"
                  hidden$="[[isUiElementHidden_(UiElement.SCAN_SUCCESS, state_)]]">
                <iron-icon class="scan-finish-image" icon="cellular-setup:checked"></iron-icon>
                <span class="label scan-finish-message" id="scanSuccessMessage">
                  [[i18n('scanQRCodeSuccess')]]
                </span>
              </div>
              <div id="scanFailureContainer"
                  hidden$="[[isUiElementHidden_(UiElement.SCAN_FAILURE, state_)]]">
                <iron-icon class="scan-finish-image" icon="cellular-setup:error"></iron-icon>
                <span class="label scan-finish-message" id="scanFailureMessage">
                  [[i18n('scanQrCodeInvalid')]]
                </span>
              </div>
            </div>
            <cr-button id="useCameraAgainButton"
                on-click="startScanning_">
              [[i18n('qrCodeRetry')]]
            </cr-button>
          </div>
        </div>
        <div class="relative">
          <cr-input id="activationCode"
            label="[[i18n('activationCode')]]"
            value="{{activationCode}}">
          </cr-input>
          <paper-spinner-lite active
              hidden$="[[!showLoadingIndicator]]">
          </paper-spinner-lite>
          <div id="loadingMessage" hidden$="[[!showLoadingIndicator]]">
              [[i18n('scanQrCodeLoading')]]
          </div>
        </div>
      </div>
    </base-page>
  </template>
  <script src="activation_code_page.js"></script>
</dom-module>
